searchData={"items":[{"type":"module","title":"ExRabbitMQAdmin","doc":"Default module for the RabbitMQ admin client.","ref":"ExRabbitMQAdmin.html"},{"type":"module","title":"Configuration - ExRabbitMQAdmin","doc":"This module uses the `ExRabbitMQAdmin.Client` macro, and can be configured\nin `config.exs`.\n\n    # config.ex\n    config :ex_rabbitmq_admin, ExRabbitMQAdmin,\n      base_url: \"https://rabbitmq.example.com:15672\",\n      username: \"guest\",\n      password: \"guest\"","ref":"ExRabbitMQAdmin.html#module-configuration"},{"type":"module","title":"Examples - ExRabbitMQAdmin","doc":"* Create a client, add basic auth by reading default values from config and\n  list all virtual hosts running in the RabbitMQ cluster.\n\n      iex> ExRabbitMQAdmin.client()\n           |> ExRabbitMQAdmin.add_basic_auth_middleware()\n           |> ExRabbitMQAdmin.Vhost.list_vhosts()\n      {:ok, %Tesla.Env{status: 200, body: [...]}}","ref":"ExRabbitMQAdmin.html#module-examples"},{"type":"function","title":"ExRabbitMQAdmin.add_basic_auth_middleware/1","doc":"Returns a `Tesla.Client` with `Tesla.Middleware.BasicAuth` middleware configured.","ref":"ExRabbitMQAdmin.html#add_basic_auth_middleware/1"},{"type":"function","title":"ExRabbitMQAdmin.add_basic_auth_middleware/2","doc":"","ref":"ExRabbitMQAdmin.html#add_basic_auth_middleware/2"},{"type":"function","title":"ExRabbitMQAdmin.add_bearer_auth_middleware/2","doc":"Returns a `Tesla.Client` with `Tesla.Middleware.BearerAuth` middleware configured.","ref":"ExRabbitMQAdmin.html#add_bearer_auth_middleware/2"},{"type":"function","title":"ExRabbitMQAdmin.add_query_middleware/2","doc":"Returns a `Tesla.Client` with `Tesla.Middleware.Query` middleware configured.","ref":"ExRabbitMQAdmin.html#add_query_middleware/2"},{"type":"function","title":"ExRabbitMQAdmin.add_query_middleware/3","doc":"","ref":"ExRabbitMQAdmin.html#add_query_middleware/3"},{"type":"function","title":"ExRabbitMQAdmin.basic_auth_middleware/1","doc":"Adds `Tesla.Middleware.BasicAuth` middleware to given `Tesla.Client` middlewares.\nUses `username` and `password` from keyword opts, or if omitted, read credentials from `config.exs`.","ref":"ExRabbitMQAdmin.html#basic_auth_middleware/1"},{"type":"function","title":"ExRabbitMQAdmin.basic_auth_middleware/2","doc":"","ref":"ExRabbitMQAdmin.html#basic_auth_middleware/2"},{"type":"function","title":"ExRabbitMQAdmin.bearer_auth_middleware/2","doc":"Adds `Tesla.Middleware.BearerAuth` middleware to given `Tesla.Client` middlewares.","ref":"ExRabbitMQAdmin.html#bearer_auth_middleware/2"},{"type":"function","title":"ExRabbitMQAdmin.client/0","doc":"Returns a `Tesla.Client` with `Tesla.Middleware.BaseUrl`, `Tesla.Middleware.Logger` and\n`Tesla.Middleware.JSON` middleware configured.","ref":"ExRabbitMQAdmin.html#client/0"},{"type":"function","title":"ExRabbitMQAdmin.client/1","doc":"","ref":"ExRabbitMQAdmin.html#client/1"},{"type":"function","title":"ExRabbitMQAdmin.cluster_name/1","doc":"Get the name of the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.html#cluster_name/1"},{"type":"function","title":"ExRabbitMQAdmin.extensions/1","doc":"Get a list of extensions to the management plugin.","ref":"ExRabbitMQAdmin.html#extensions/1"},{"type":"function","title":"ExRabbitMQAdmin.overview/1","doc":"Get various bits of infroamtion about the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.html#overview/1"},{"type":"function","title":"ExRabbitMQAdmin.query_middleware/2","doc":"Adds `Tesla.Middleware.Query` middleware to given `Tesla.Client` middlewares.","ref":"ExRabbitMQAdmin.html#query_middleware/2"},{"type":"function","title":"ExRabbitMQAdmin.whoami/1","doc":"Get details of the currently authenticated user.","ref":"ExRabbitMQAdmin.html#whoami/1"},{"type":"module","title":"ExRabbitMQAdmin.Binding","doc":"RabbitMQ Bindings.","ref":"ExRabbitMQAdmin.Binding.html"},{"type":"function","title":"ExRabbitMQAdmin.Binding.create_exchange_exchange_binding/5","doc":"Create a binding between two exchanges in a given virtual host.","ref":"ExRabbitMQAdmin.Binding.html#create_exchange_exchange_binding/5"},{"type":"function","title":"Params - ExRabbitMQAdmin.Binding.create_exchange_exchange_binding/5","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `src` - type: `string`, required: `true`\n  * `dest` - type: `string`, required: `true`\n  * `:routing_key` (`t:String.t/0`) - Required. The routing key used to route the message to its destination.\n\n* `:arguments` (map of `t:String.t/0` keys and `t:term/0` values) - Optional binding arguments passed to RabbitMQ when creating the binding.\n  Please consult the official documentation for supported arguments (as they can vary\n  for exchange type).\n\n\n\nThe response will contain a `Location` header with the URI of the newly created binding.","ref":"ExRabbitMQAdmin.Binding.html#create_exchange_exchange_binding/5-params"},{"type":"function","title":"ExRabbitMQAdmin.Binding.create_exchange_queue_binding/5","doc":"Create a binding between an exchange and a queue in a given virtual host.","ref":"ExRabbitMQAdmin.Binding.html#create_exchange_queue_binding/5"},{"type":"function","title":"Params - ExRabbitMQAdmin.Binding.create_exchange_queue_binding/5","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `exchange` - type: `string`, required: `true`\n  * `queue` - type: `string`, required: `true`\n  * `:routing_key` (`t:String.t/0`) - Required. The routing key used to route the message to its destination.\n\n* `:arguments` (map of `t:String.t/0` keys and `t:term/0` values) - Optional binding arguments passed to RabbitMQ when creating the binding.\n  Please consult the official documentation for supported arguments (as they can vary\n  for exchange type).\n\n\n\nThe response will contain a `Location` header with the URI of the newly created binding.","ref":"ExRabbitMQAdmin.Binding.html#create_exchange_queue_binding/5-params"},{"type":"function","title":"ExRabbitMQAdmin.Binding.list_bindings/1","doc":"List all bindings on the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Binding.html#list_bindings/1"},{"type":"function","title":"ExRabbitMQAdmin.Binding.list_exchange_exchange_bindings/4","doc":"List all bindings between two exchanges in a given virtual host.","ref":"ExRabbitMQAdmin.Binding.html#list_exchange_exchange_bindings/4"},{"type":"function","title":"ExRabbitMQAdmin.Binding.list_exchange_queue_bindings/4","doc":"List all bindings between an exchange and a queue in a given virtual host.","ref":"ExRabbitMQAdmin.Binding.html#list_exchange_queue_bindings/4"},{"type":"function","title":"ExRabbitMQAdmin.Binding.list_vhost_bindings/2","doc":"List all bindings in a given virtual host.","ref":"ExRabbitMQAdmin.Binding.html#list_vhost_bindings/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Binding.list_vhost_bindings/2","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.Binding.html#list_vhost_bindings/2-params"},{"type":"module","title":"ExRabbitMQAdmin.Client","doc":"Macro for creating RabbitMQ HTTP API client.","ref":"ExRabbitMQAdmin.Client.html"},{"type":"module","title":"Configuration - ExRabbitMQAdmin.Client","doc":"Some options, such as e.g. `base_url` can be read from config. If you want to use\nthis macro in a module, you can add a corresponding entry in your `config.exs` file\nto configure the client.\n\n    # config.ex\n    config :my_app, MyApp.RabbitClient,\n      base_url: \"https://rabbitmq.example.com:15672\",\n      username: \"guest\",\n      password: \"guest\"\n\n#### Parameters\n\n* `otp_app` - Namespace used to look up configuration values such as `base_url` and others.","ref":"ExRabbitMQAdmin.Client.html#module-configuration"},{"type":"module","title":"Example - ExRabbitMQAdmin.Client","doc":"defmodule MyApp.RabbitClient do\n      use ExRabbitMQAdmin.Client, otp_app: :my_app\n    end","ref":"ExRabbitMQAdmin.Client.html#module-example"},{"type":"module","title":"ExRabbitMQAdmin.Definition","doc":"","ref":"ExRabbitMQAdmin.Definition.html"},{"type":"function","title":"ExRabbitMQAdmin.Definition.list_definitions/1","doc":"List all server definitions - exchanges, queues, bindings, users,\nvirtual hosts, permissions, topic permissions, and parameters.","ref":"ExRabbitMQAdmin.Definition.html#list_definitions/1"},{"type":"function","title":"ExRabbitMQAdmin.Definition.list_vhost_definitions/2","doc":"List all definitions for a specific virtual host.","ref":"ExRabbitMQAdmin.Definition.html#list_vhost_definitions/2"},{"type":"module","title":"ExRabbitMQAdmin.Exchange","doc":"RabbitMQ Exchanges.","ref":"ExRabbitMQAdmin.Exchange.html"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.delete_exchange/4","doc":"Delete a specific exchange under a virtual host by name.","ref":"ExRabbitMQAdmin.Exchange.html#delete_exchange/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.delete_exchange/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `name` - type: `string`, required: `true`\n  * `:if_unused` (`t:boolean/0`) - If true, prevent deleting the exchange if it is bound to a queue or acts as a\n  source for another exchange.","ref":"ExRabbitMQAdmin.Exchange.html#delete_exchange/4-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.get_exchange/3","doc":"Get an individual exchange by name under a virtual host.","ref":"ExRabbitMQAdmin.Exchange.html#get_exchange/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.get_exchange/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `name` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.Exchange.html#get_exchange/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.list_exchange_dest_bindings/3","doc":"List all bindings in which the given exchange is the *destination*.","ref":"ExRabbitMQAdmin.Exchange.html#list_exchange_dest_bindings/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.list_exchange_dest_bindings/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `name` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.Exchange.html#list_exchange_dest_bindings/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.list_exchange_src_bindings/3","doc":"List all bindings in which the given exchange is the *source*.","ref":"ExRabbitMQAdmin.Exchange.html#list_exchange_src_bindings/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.list_exchange_src_bindings/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `name` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.Exchange.html#list_exchange_src_bindings/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.list_exchanges/2","doc":"List all exchanges on the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Exchange.html#list_exchanges/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.list_exchanges/2","doc":"* `client` - Tesla client used to perform the request.\n  * `:page` (`t:non_neg_integer/0`) - Page number to fetch if paginating the results.\n\n* `:page_size` (`t:non_neg_integer/0`) - Number of elements per page, defaults to 100.\n\n* `:name` (`t:String.t/0`) - Filter by name, for example queue name, exchange name, etc.\n\n* `:use_regex` (`t:boolean/0`) - Enables regular expression for the param `name`.","ref":"ExRabbitMQAdmin.Exchange.html#list_exchanges/2-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.list_vhost_exchanges/3","doc":"List all exchanges in a given virtual host. Optionally pass pagination parameters\nto filter exchanges.","ref":"ExRabbitMQAdmin.Exchange.html#list_vhost_exchanges/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.list_vhost_exchanges/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `:page` (`t:non_neg_integer/0`) - Page number to fetch if paginating the results.\n\n* `:page_size` (`t:non_neg_integer/0`) - Number of elements per page, defaults to 100.\n\n* `:name` (`t:String.t/0`) - Filter by name, for example queue name, exchange name, etc.\n\n* `:use_regex` (`t:boolean/0`) - Enables regular expression for the param `name`.","ref":"ExRabbitMQAdmin.Exchange.html#list_vhost_exchanges/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.publish_message/4","doc":"Publish a message to the given exchange.\nPlease not that this is *not* an optimal way to publish messages\nto a queue. Consider using a library like [AMQP](https://hexdocs.pm/amqp/readme.html).","ref":"ExRabbitMQAdmin.Exchange.html#publish_message/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.publish_message/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `name` - type: `string`, required: `true`\n  * `:properties` (map of `t:String.t/0` keys and `t:term/0` values) - Message properties. The default value is `%{}`.\n\n* `:routing_key` (`t:String.t/0`) - Required. The routing key used to route the message to its destination.\n\n* `:payload` - Required. Message to be sent.\n\n* `:payload_encoding` - If set to `string` the payload will be sent as an UTF-8 encoded string.\n  If `base64`, the message payload should be base64 encoded. The default value is `:string`.\n\n\n\n\nIf the message is published successfully to at least one queue,\nit will respond with:\n\n```\n%{\"routed\" => true}\n```","ref":"ExRabbitMQAdmin.Exchange.html#publish_message/4-params"},{"type":"function","title":"ExRabbitMQAdmin.Exchange.put_exchange/4","doc":"Create a new exchange under a virtual host with given name.","ref":"ExRabbitMQAdmin.Exchange.html#put_exchange/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Exchange.put_exchange/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `name` - type: `string`, required: `true`\n  * `:arguments` (map of `t:String.t/0` keys and `t:term/0` values) - Optional exchange arguments passed to RabbitMQ when creating the exchange.\n  Please consult the official documentation for supported arguments (as they can vary\n  for exchange type).\n\n* `:auto_delete` (`t:boolean/0`) - If true, the exchange is auto-deleted once the last bound object is unbound from\n  the exchange. The default value is `false`.\n\n* `:durable` (`t:boolean/0`) - Durable exchanges survives server restarts and lasts until explicitly deleted. The default value is `true`.\n\n* `:internal` (`t:boolean/0`) - Internal exchanges are meant for internal RabbitMQ tasks only. The default value is `false`.\n\n* `:type` - Exchange types defines how messages are routed by using different parameters and\n  bindings. The default value is `:direct`.","ref":"ExRabbitMQAdmin.Exchange.html#put_exchange/4-params"},{"type":"module","title":"ExRabbitMQAdmin.Node","doc":"Get information about nodes in the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Node.html"},{"type":"function","title":"ExRabbitMQAdmin.Node.get_node/3","doc":"Get information about a specific node in the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Node.html#get_node/3"},{"type":"function","title":"ExRabbitMQAdmin.Node.list_nodes/1","doc":"Get a list of nodes in the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Node.html#list_nodes/1"},{"type":"module","title":"ExRabbitMQAdmin.Permission","doc":"This module contains functions for interacting with RabbitMQ permissions.","ref":"ExRabbitMQAdmin.Permission.html"},{"type":"function","title":"ExRabbitMQAdmin.Permission.delete_vhost_user_permissions/3","doc":"Delete permissions for a user on a specific vhost.","ref":"ExRabbitMQAdmin.Permission.html#delete_vhost_user_permissions/3"},{"type":"function","title":"ExRabbitMQAdmin.Permission.get_permissions/1","doc":"Get a list of permissions for all users.","ref":"ExRabbitMQAdmin.Permission.html#get_permissions/1"},{"type":"function","title":"ExRabbitMQAdmin.Permission.get_vhost_user_permissions/3","doc":"Get list of permissions for a user on a specific vhost.","ref":"ExRabbitMQAdmin.Permission.html#get_vhost_user_permissions/3"},{"type":"function","title":"ExRabbitMQAdmin.Permission.put_vhost_user_permissions/4","doc":"Set permissions for a user on a specific vhost.","ref":"ExRabbitMQAdmin.Permission.html#put_vhost_user_permissions/4"},{"type":"module","title":"ExRabbitMQAdmin.Queue","doc":"This module contains functions for interacting with RabbitMQ queues.","ref":"ExRabbitMQAdmin.Queue.html"},{"type":"function","title":"ExRabbitMQAdmin.Queue.delete_queue/4","doc":"Delete an existing queue under a virtual host.","ref":"ExRabbitMQAdmin.Queue.html#delete_queue/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.delete_queue/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to delete.\n  * `:if_empty` (`t:boolean/0`) - If true, prevent deleting the queue if it contains any messages.\n  This option is not supported by `quorum` queues.\n\n* `:if_unused` (`t:boolean/0`) - If true, prevent deleting the queue if it has any consumers.\n  This option is not supported by `quorum` queues.","ref":"ExRabbitMQAdmin.Queue.html#delete_queue/4-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.get_queue/3","doc":"Get an individual queue under a virtual host by name.","ref":"ExRabbitMQAdmin.Queue.html#get_queue/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.get_queue/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to get.","ref":"ExRabbitMQAdmin.Queue.html#get_queue/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.list_queue_bindings/3","doc":"List all bindings for a queue under a virtual host.","ref":"ExRabbitMQAdmin.Queue.html#list_queue_bindings/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.list_queue_bindings/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to get bindings for.","ref":"ExRabbitMQAdmin.Queue.html#list_queue_bindings/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.list_queues/2","doc":"List all queues running on the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Queue.html#list_queues/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.list_queues/2","doc":"* `client` - Tesla client used to perform the request.\n  * `:page` (`t:non_neg_integer/0`) - Page number to fetch if paginating the results.\n\n* `:page_size` (`t:non_neg_integer/0`) - Number of elements per page, defaults to 100.\n\n* `:name` (`t:String.t/0`) - Filter by name, for example queue name, exchange name, etc.\n\n* `:use_regex` (`t:boolean/0`) - Enables regular expression for the param `name`.","ref":"ExRabbitMQAdmin.Queue.html#list_queues/2-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.list_vhost_queues/3","doc":"List all queues in a given virtual host running on the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Queue.html#list_vhost_queues/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.list_vhost_queues/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - Name of the virtual host.\n  * `:page` (`t:non_neg_integer/0`) - Page number to fetch if paginating the results.\n\n* `:page_size` (`t:non_neg_integer/0`) - Number of elements per page, defaults to 100.\n\n* `:name` (`t:String.t/0`) - Filter by name, for example queue name, exchange name, etc.\n\n* `:use_regex` (`t:boolean/0`) - Enables regular expression for the param `name`.","ref":"ExRabbitMQAdmin.Queue.html#list_vhost_queues/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.perform_queue_action/4","doc":"Perform an action on a queue.","ref":"ExRabbitMQAdmin.Queue.html#perform_queue_action/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.perform_queue_action/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to perform actions for.\n  * `action` - type: `atom`, Action to perform. Currently only supports `:sync` and `:cancel_sync`","ref":"ExRabbitMQAdmin.Queue.html#perform_queue_action/4-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.purge_queue/3","doc":"Purge all messages on a queue under a virtual host.","ref":"ExRabbitMQAdmin.Queue.html#purge_queue/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.purge_queue/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to purge messages from.","ref":"ExRabbitMQAdmin.Queue.html#purge_queue/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.put_queue/4","doc":"Create a new queue under a virtual host.","ref":"ExRabbitMQAdmin.Queue.html#put_queue/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.put_queue/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to get.\n  * `:auto_delete` (`t:boolean/0`) - If true, automatically delete the queue when the last consumer disconnects. The default value is `false`.\n\n* `:durable` (`t:boolean/0`) - If true, messages are persisted on disk. This can lead to lower throughput, but better\n  data consistency. The default value is `true`.\n\n* `:node` (`t:String.t/0`) - If set, start the queue on given node name.\n\n* `:arguments` (map of `t:String.t/0` keys and `t:term/0` values) - Optional queue arguments (x-arguments) passed to RabbitMQ when creating the queue.\n  Please consult the official documentation for supported arguments (as they vary for\n  queue type and installed plugins).","ref":"ExRabbitMQAdmin.Queue.html#put_queue/4-params"},{"type":"function","title":"ExRabbitMQAdmin.Queue.receive_queue_messages/4","doc":"Receive messages from a queue under a virtual host.\nPlease not that this is *not* an optimal way to consume messages\nfrom a queue. Consider using a library like [AMQP](https://hexdocs.pm/amqp/readme.html).","ref":"ExRabbitMQAdmin.Queue.html#receive_queue_messages/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Queue.receive_queue_messages/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, Virtual host for the queue.\n  * `queue` - type: `string`, Name of the queue to receive messages from.\n  * `:count` (`t:pos_integer/0`) - Maximum number of messages to receive. You may get fewer messages if the queue\n  cannot immediately provide them. The default value is `1`.\n\n* `:ackmode` - Required. Determines if the messages will be removed from the queue. If set to `ack_requeue_true`\n  or `reject_requeue_true`, the messages will be re-queued. If set to `ack_requeue_false`,\n  or `reject_requeue_false`, they will be removed.\n\n* `:encoding` - If set to `auto`, message payload will be returned as string if it is valid UTF-8, or\n  base64 encoded otherwise. If set to `base64` message payload will always be base64 encoded. The default value is `:auto`.\n\n* `:truncate` (`t:pos_integer/0`) - If present, truncate the message payload if larger than given size (in bytes).","ref":"ExRabbitMQAdmin.Queue.html#receive_queue_messages/4-params"},{"type":"module","title":"ExRabbitMQAdmin.User","doc":"This module contains functions for interacting with RabbitMQ users.","ref":"ExRabbitMQAdmin.User.html"},{"type":"function","title":"ExRabbitMQAdmin.User.bulk_delete_users/2","doc":"Delete all users in given list.","ref":"ExRabbitMQAdmin.User.html#bulk_delete_users/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.bulk_delete_users/2","doc":"* `client` - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.User.html#bulk_delete_users/2-params"},{"type":"function","title":"ExRabbitMQAdmin.User.delete_user/2","doc":"Deletes an individual user by given name.","ref":"ExRabbitMQAdmin.User.html#delete_user/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.delete_user/2","doc":"* `client` - Tesla client used to perform the request.\n  * `user` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.User.html#delete_user/2-params"},{"type":"function","title":"ExRabbitMQAdmin.User.get_user/2","doc":"Get an individual user by name.","ref":"ExRabbitMQAdmin.User.html#get_user/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.get_user/2","doc":"* `client` - Tesla client used to perform the request.\n  * `user` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.User.html#get_user/2-params"},{"type":"function","title":"ExRabbitMQAdmin.User.get_user_permissions/2","doc":"Get all permissions for an individual user.","ref":"ExRabbitMQAdmin.User.html#get_user_permissions/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.get_user_permissions/2","doc":"* `client` - Tesla client used to perform the request.\n  * `user` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.User.html#get_user_permissions/2-params"},{"type":"function","title":"ExRabbitMQAdmin.User.get_user_topic_permissions/2","doc":"Get all topic permissions for an individual user.","ref":"ExRabbitMQAdmin.User.html#get_user_topic_permissions/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.get_user_topic_permissions/2","doc":"* `client` - Tesla client used to perform the request.\n  * `user` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.User.html#get_user_topic_permissions/2-params"},{"type":"function","title":"ExRabbitMQAdmin.User.hash_password/1","doc":"Hash the given password using the hashing algorithm described\n[here](https://rabbitmq.com/passwords.html#computing-password-hash).\n\nRabbitMQ by default relies on (weak) hashed password, but we're enforcing\nthe strongest supported hashing algorithm (sha512).\n\nIf possible, avoid using passwords and authenticate using other means\nsuch as [TLS certificates](https://rabbitmq.com/passwords.html#x509-certificate-authentication).","ref":"ExRabbitMQAdmin.User.html#hash_password/1"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.hash_password/1","doc":"* `password` - type: `string`, required: `true`","ref":"ExRabbitMQAdmin.User.html#hash_password/1-params"},{"type":"function","title":"ExRabbitMQAdmin.User.list_users/1","doc":"List all users in the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.User.html#list_users/1"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.list_users/1","doc":"* `client` - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.User.html#list_users/1-params"},{"type":"function","title":"ExRabbitMQAdmin.User.list_users_without_permissions/1","doc":"List users in the RabbitMQ cluster that have no access to any virtual host.","ref":"ExRabbitMQAdmin.User.html#list_users_without_permissions/1"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.list_users_without_permissions/1","doc":"* `client` - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.User.html#list_users_without_permissions/1-params"},{"type":"function","title":"ExRabbitMQAdmin.User.put_user/3","doc":"Create a new user with given name.\nRabbitMQ currently only supports weak password hashing algorithms, and\nshould be avoided if possible. If passing a blank password, a password-less\nuser will be created. This user will not be able to authenticate with\nbasic auth, and must use other means (such as TLS certificates).","ref":"ExRabbitMQAdmin.User.html#put_user/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.User.put_user/3","doc":"* `client` - Tesla client used to perform the request.\n  * `user` - type: `string`, required: `true`\n  * `:password` (`t:String.t/0`) - Required. The password that will be used for the created user. All passwords will be hashed using the\n  `rabbit_password_hashing_sha512` hashing algorithm before sent to over the wire.\n  If blank password, users will not be able to login using a password, but other mechanisms\n  like client certificates may be used.\n\n* `:tags` (`t:String.t/0`) - Required. Comma-separated list of tags for the user. Currently only `administrator`, `monitoring`\n  and `management` are recognized.","ref":"ExRabbitMQAdmin.User.html#put_user/3-params"},{"type":"module","title":"ExRabbitMQAdmin.Vhost","doc":"This module contains functions for interacting with RabbitMQ virtual hosts.","ref":"ExRabbitMQAdmin.Vhost.html"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.delete_vhost/2","doc":"Delete a specific virtual host by vhost.","ref":"ExRabbitMQAdmin.Vhost.html#delete_vhost/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.delete_vhost/2","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, The vhost of the virtual host that should be deleted.","ref":"ExRabbitMQAdmin.Vhost.html#delete_vhost/2-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.get_vhost/2","doc":"Get an individual virtual host by vhost.","ref":"ExRabbitMQAdmin.Vhost.html#get_vhost/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.get_vhost/2","doc":"* `client` - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.Vhost.html#get_vhost/2-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.list_vhost_channels/3","doc":"List all open channels for a specific virtual host.\nOptionally pass pagination parameters to filter channels.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_channels/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.list_vhost_channels/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `:page` (`t:non_neg_integer/0`) - Page number to fetch if paginating the results.\n\n* `:page_size` (`t:non_neg_integer/0`) - Number of elements per page, defaults to 100.\n\n* `:name` (`t:String.t/0`) - Filter by name, for example queue name, exchange name, etc.\n\n* `:use_regex` (`t:boolean/0`) - Enables regular expression for the param `name`.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_channels/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.list_vhost_connections/3","doc":"List all open open connections in a specific virtual host.\nOptionally pass pagination parameters to filter connections.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_connections/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.list_vhost_connections/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `:page` (`t:non_neg_integer/0`) - Page number to fetch if paginating the results.\n\n* `:page_size` (`t:non_neg_integer/0`) - Number of elements per page, defaults to 100.\n\n* `:name` (`t:String.t/0`) - Filter by name, for example queue name, exchange name, etc.\n\n* `:use_regex` (`t:boolean/0`) - Enables regular expression for the param `name`.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_connections/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.list_vhost_permissions/2","doc":"List all permissions for a specific virtual host.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_permissions/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.list_vhost_permissions/2","doc":"* `client` - Tesla client used to perform the request.\n* `vhost` - type: `string`, The vhost of the vhost to list permissions for.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_permissions/2-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.list_vhost_topic_permissions/2","doc":"List all topic permissions for a specific virtual host.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_topic_permissions/2"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.list_vhost_topic_permissions/2","doc":"* `client` - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_topic_permissions/2-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.list_vhosts/1","doc":"List all virtual hosts running on the RabbitMQ cluster.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhosts/1"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.list_vhosts/1","doc":"* `client` - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhosts/1-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.put_vhost/3","doc":"Create a new virtual host with given vhost.","ref":"ExRabbitMQAdmin.Vhost.html#put_vhost/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.put_vhost/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, required: `true`\n  * `:description` (`t:String.t/0`) - Optional description for virtual host. The default value is `\"\"`.\n\n* `:tags` (`t:String.t/0`) - Tags is an optional comma-separated list of tags. The default value is `\"\"`.","ref":"ExRabbitMQAdmin.Vhost.html#put_vhost/3-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.put_vhost_permissions/4","doc":"Set permissions for a user on a specific virtual host.\nRabbitMQ permissions are defined as triplets of regular expressions.\n\nPlease consult the\n[official documentation](https://www.rabbitmq.com/access-control.html#authorisation)\nfor more details.","ref":"ExRabbitMQAdmin.Vhost.html#put_vhost_permissions/4"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.put_vhost_permissions/4","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, The vhost of the vhost to assign permissions for.\n  * `user` - type: `string`, The username to assign permissions for.\n  * `:configure` (`t:String.t/0`) - Required. A regular expression that will determine the `configure` permissions for the given resource.\n  Defaults to deny-all. The default value is `\"^$\"`.\n\n* `:write` (`t:String.t/0`) - Required. A regular expression that will determine the `write` permissions for the given resource.\n  Defaults to deny-all. The default value is `\"^$\"`.\n\n* `:read` (`t:String.t/0`) - Required. A regular expression that will determine the `read` permissions for the given resource.\n  Defaults to deny-all. The default value is `\"^$\"`.","ref":"ExRabbitMQAdmin.Vhost.html#put_vhost_permissions/4-params"},{"type":"function","title":"ExRabbitMQAdmin.Vhost.start_vhost/3","doc":"Start a specific virtual host on given node.","ref":"ExRabbitMQAdmin.Vhost.html#start_vhost/3"},{"type":"function","title":"Params - ExRabbitMQAdmin.Vhost.start_vhost/3","doc":"* `client` - Tesla client used to perform the request.\n  * `vhost` - type: `string`, The vhost of the virtual host that should be started.\n  * `node` - type: `string`, The vhost of the node that the virtual host should be started on.","ref":"ExRabbitMQAdmin.Vhost.html#start_vhost/3-params"},{"type":"extras","title":"README","doc":"![Elixir CI](https://github.com/Intility/ex_rabbitmq_admin/actions/workflows/elixir.yaml/badge.svg?event=push)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ex_rabbitmq_admin.svg)](https://hex.pm/packages/ex_rabbitmq_admin)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ex_rabbitmq_admin/readme.html)\n\n# ExRabbitMQAdmin\n\nSimple client library for the RabbitMQ [HTTP API](https://www.rabbitmq.com/management.html#http-api),\nbuilt on [Tesla](https://github.com/elixir-tesla/tesla).\n\nRead the full documentation [here](https://hexdocs.pm/ex_rabbitmq_admin/readme.html).","ref":"readme.html"},{"type":"extras","title":"Supported functionality - README","doc":"- [ ] Basic information endpoints (listing connections, channels, nodes, and so on)\n- [x] Client adapter configuration\n- [x] User management endpoints\n- [x] Virtual host endpoints\n- [x] Queue endpoints\n- [x] Exchange endpoints\n- [x] Bindings endpoints\n- [ ] Parameters\n- [ ] Policies endpoints\n- [ ] Operator endpoints\n- [ ] Health check endpoints","ref":"readme.html#supported-functionality"},{"type":"extras","title":"Installation - README","doc":"This package is [available in Hex](https://hex.pm/packages/ex_rabbitmq_admin), and can be installed\nby adding `ex_rabbitmq_admin` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_rabbitmq_admin, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Example usage - README","doc":"First step is to set up some basic configuration in your `config.exs` file.\n\n```elixir\n# config.exs\n\nconfig :ex_rabbitmq_admin, ExRabbitMQAdmin,\n  base_url: \"https://rabbitmq.example.com:56721\"\n```\n\nNext, you can use the `ExRabbitMQAdmin` client from wherever you want.\n\n```elixir\ndefmodule RabbitMQControl do\n  alias ExRabbitMQAdmin\n\n  @doc \"\"\"\n  Creates a new user on the RabbitMQ cluster.\n  \"\"\"\n  def create_rabbit_user(username, password) do\n    {:ok, %Tesla.Env{status: 201}} =\n      ExRabbitMQAdmin.client()\n      |> ExRabbitMQAdmin.add_basic_auth_middleware(username: \"rabbit-admin\", password: \"secret-password\")\n      |> ExRabbitMQAdmin.User.put_user(username, password: password, tags: \"moderator\")\n  end\n\n  # Or maybe you want to list virtual hosts\n  def virtual_hosts do\n    {:ok, %Tesla.Env{:status: 200, body: response}} =\n      ExRabbitMQAdmin.client()\n      |> ExRabbitMQAdmin.add_basic_auth_middleware(username: \"rabbit-admin\", password: \"secret-password\")\n      |> ExRabbitMQAdmin.Vhost.list_vhosts()\n  end\nend\n```","ref":"readme.html#example-usage"},{"type":"extras","title":"Contribution - README","doc":"The RabbitMQ HTTP API documentation is available [here](https://rawcdn.githack.com/rabbitmq/rabbitmq-server/v3.11.2/deps/rabbitmq_management/priv/www/api/index.html).","ref":"readme.html#contribution"},{"type":"extras","title":"Running the test suite - README","doc":"```shell\n$ mix coveralls.html\n```","ref":"readme.html#running-the-test-suite"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2022 Intility AS\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}